function out = model
%
% EPuAM_TDE_model.m
%
% Model exported on Sep 5 2018, 16:24 by COMSOL 5.3.0.316.

import com.comsol.model.*
import com.comsol.model.util.*

model = ModelUtil.create('Model');

model.modelPath('D:\David Pritchet\COMSOL_SIMS\JP1 sims');

model.label('EPuAM_TDE_model.mph');

model.comments(['Untitled\n\n']);

model.param.set('frq', '1[Hz]', 'Waveform frequency');
model.param.set('p_a', '10[um]', 'particle x semiaxis');
model.param.set('p_b', '10[um]', 'particle y semiaxis');
model.param.set('coef_in', '0.8', 'particle inner shell coefficient');
model.param.set('coef_out', '1.2', 'particle outer shell coefficient');
model.param.set('l_domain', '500[um]', 'simulation domain length');
model.param.set('p_area', 'p_a*p_b*pi', 'area of ellipse/particle');
model.param.set('x_offset', '0[um]', 'domain midpoint particle x coordinate');
model.param.set('y_offset', '0[um]', 'domain midpoint paritcle y coordinate');
model.param.set('p_rot', '0[deg]', 'particle angle rotation');

model.component.create('comp1', true);

model.component('comp1').geom.create('geom1', 2);

model.result.table.create('tbl1', 'Table');
model.result.table.create('tbl2', 'Table');

model.func.create('wv1', 'Wave');
model.func.create('wv2', 'Wave');
model.func.create('wv3', 'Wave');
model.func.create('an1', 'Analytic');
model.func.create('an2', 'Analytic');
model.func.create('an3', 'Analytic');
model.func('wv1').label('Pulse_WF');
model.func('wv1').set('funcname', 'Pulse');
model.func('wv1').set('type', 'square');
model.func('wv1').set('smooth', '0.05/(10*frq)');
model.func('wv1').set('freq', '2*pi*frq');
model.func('wv2').label('Saw_WF');
model.func('wv2').set('funcname', 'Sawtooth');
model.func('wv2').set('type', 'sawtooth');
model.func('wv2').set('smooth', '0.05/(10*frq)');
model.func('wv2').set('freq', '2*pi*frq*10');
model.func('wv3').label('Sine_WF');
model.func('wv3').set('funcname', 'Sine');
model.func('wv3').set('freq', '2*pi*frq');
model.func('an1').label('PWM_topBC');
model.func('an1').set('funcname', 'PWM_BC');
model.func('an1').set('expr', 'Sine(x) > Sawtooth(x)');
model.func('an1').set('plotargs', {'x' '0' '(1/frq)*2'});
model.func('an2').label('Sine_topBC');
model.func('an2').set('funcname', 'Sine_BC');
model.func('an2').set('expr', 'Sine(x)*0.5+0.5');
model.func('an2').set('plotargs', {'x' '0' '(1/frq)*2'});
model.func('an3').label('Pulse_topBC');
model.func('an3').set('funcname', 'Pulse_BC');
model.func('an3').set('expr', 'Pulse(x)*0.5+0.5');
model.func('an3').set('plotargs', {'x' '0' '(1/frq)*2'});

model.component('comp1').mesh.create('mesh1');

model.component('comp1').geom('geom1').lengthUnit([native2unicode(hex2dec({'00' 'b5'}), 'unicode') 'm']);
model.component('comp1').geom('geom1').create('sq1', 'Square');
model.component('comp1').geom('geom1').feature('sq1').label('Model 2D domain');
model.component('comp1').geom('geom1').feature('sq1').set('size', 'l_domain');
model.component('comp1').geom('geom1').create('e1', 'Ellipse');
model.component('comp1').geom('geom1').feature('e1').label('Particle');
model.component('comp1').geom('geom1').feature('e1').set('pos', {'l_domain/2+x_offset' 'l_domain/2+y_offset'});
model.component('comp1').geom('geom1').feature('e1').set('rot', 'p_rot');
model.component('comp1').geom('geom1').feature('e1').set('semiaxes', {'p_a' 'p_b'});
model.component('comp1').geom('geom1').create('e2', 'Ellipse');
model.component('comp1').geom('geom1').feature('e2').label('Particle Inner SHell');
model.component('comp1').geom('geom1').feature('e2').set('pos', {'l_domain/2+x_offset' 'l_domain/2+y_offset'});
model.component('comp1').geom('geom1').feature('e2').set('rot', 'p_rot');
model.component('comp1').geom('geom1').feature('e2').set('semiaxes', {'p_a*coef_in' 'p_b*coef_in'});
model.component('comp1').geom('geom1').run;
model.component('comp1').geom('geom1').run('fin');

model.component('comp1').material.create('mat1', 'Common');
model.component('comp1').material.create('mat2', 'Common');
model.component('comp1').material('mat1').selection.set([1]);
model.component('comp1').material('mat2').selection.set([2 3]);

model.component('comp1').physics.create('ec', 'ConductiveMedia', 'geom1');
model.component('comp1').physics('ec').create('gnd1', 'Ground', 1);
model.component('comp1').physics('ec').feature('gnd1').selection.set([2]);
model.component('comp1').physics('ec').create('pot1', 'ElectricPotential', 1);
model.component('comp1').physics('ec').feature('pot1').selection.set([3]);
model.component('comp1').physics('ec').create('fcal1', 'ForceCalculation', 2);
model.component('comp1').physics('ec').feature('fcal1').selection.set([2 3]);

model.component('comp1').mesh('mesh1').create('dis1', 'Distribution');
model.component('comp1').mesh('mesh1').create('dis2', 'Distribution');
model.component('comp1').mesh('mesh1').create('dis3', 'Distribution');
model.component('comp1').mesh('mesh1').create('ftri1', 'FreeTri');
model.component('comp1').mesh('mesh1').feature('dis1').selection.set([5 6 9 12]);
model.component('comp1').mesh('mesh1').feature('dis2').selection.set([7 8 10 11]);
model.component('comp1').mesh('mesh1').feature('dis3').selection.set([1 2 3 4]);

model.result.table('tbl1').comments('Maxwell downward surface electric stress tensor (ec.dnTex*1[m], ec.dnTey*1[m])');
model.result.table('tbl2').comments('computed EM force (ec.Forcex_EM/1[m], ec.Forcey_EM/1[m])');

model.component('comp1').view('view1').axis.set('xmin', -306.13836669921875);
model.component('comp1').view('view1').axis.set('xmax', 806.1383666992188);
model.component('comp1').view('view1').axis.set('ymin', -60.111572265625);
model.component('comp1').view('view1').axis.set('ymax', 560.111572265625);
model.component('comp1').view('view1').axis.set('abstractviewlratio', -0.6162053346633911);
model.component('comp1').view('view1').axis.set('abstractviewrratio', 0.6162053346633911);
model.component('comp1').view('view1').axis.set('abstractviewbratio', -0.05000000074505806);
model.component('comp1').view('view1').axis.set('abstractviewtratio', 0.05000000074505806);
model.component('comp1').view('view1').axis.set('abstractviewxscale', 0.4910714030265808);
model.component('comp1').view('view1').axis.set('abstractviewyscale', 0.4910714328289032);

model.component('comp1').material('mat1').label('Water');
model.component('comp1').material('mat1').propertyGroup('def').set('relpermittivity', {'80.1' '0' '0' '0' '80.1' '0' '0' '0' '80.1'});
model.component('comp1').material('mat1').propertyGroup('def').set('electricconductivity', {'25[mS/m]' '0' '0' '0' '25[mS/m]' '0' '0' '0' '25[mS/m]'});
model.component('comp1').material('mat2').propertyGroup('def').set('electricconductivity', {'10e-14' '0' '0' '0' '10e-14' '0' '0' '0' '10e-14'});
model.component('comp1').material('mat2').propertyGroup('def').set('relpermittivity', {'9.9' '0' '0' '0' '9.9' '0' '0' '0' '9.9'});

model.component('comp1').physics('ec').feature('pot1').set('V0', 'Pulse_BC(t*1[1/s])');
model.component('comp1').physics('ec').feature('fcal1').set('ForceName', 'EM');

model.component('comp1').mesh('mesh1').feature('size').set('custom', 'on');
model.component('comp1').mesh('mesh1').feature('size').set('hmax', 25);
model.component('comp1').mesh('mesh1').feature('size').set('hmin', 0.05);
model.component('comp1').mesh('mesh1').feature('size').set('hcurve', 0.5);
model.component('comp1').mesh('mesh1').feature('size').set('hgrad', 1.1);
model.component('comp1').mesh('mesh1').feature('dis1').label('Particle surface distribution');
model.component('comp1').mesh('mesh1').feature('dis1').set('numelem', 24);
model.component('comp1').mesh('mesh1').feature('dis2').label('Particle inner shell distribution');
model.component('comp1').mesh('mesh1').feature('dis2').set('numelem', 20);
model.component('comp1').mesh('mesh1').feature('dis3').label('Bomain boundary condition distribution');
model.component('comp1').mesh('mesh1').feature('dis3').set('numelem', 40);
model.component('comp1').mesh('mesh1').run;

model.study.create('std1');
model.study('std1').create('time', 'Transient');

model.sol.create('sol1');
model.sol('sol1').study('std1');
model.sol('sol1').attach('std1');
model.sol('sol1').create('st1', 'StudyStep');
model.sol('sol1').create('v1', 'Variables');
model.sol('sol1').create('t1', 'Time');
model.sol('sol1').feature('t1').create('fc1', 'FullyCoupled');
model.sol('sol1').feature('t1').feature.remove('fcDef');

model.result.dataset.remove('dset1');
model.result.create('pg3', 'PlotGroup1D');
model.result.create('pg4', 'PlotGroup1D');
model.result('pg3').create('tblp1', 'Table');
model.result('pg4').create('tblp1', 'Table');

model.study('std1').feature('time').set('tlist', 'range(0,((1/frq)*2-0)/3999,(1/frq)*2)');

model.sol('sol1').attach('std1');
model.sol('sol1').feature('st1').set('splitcomplex', true);
model.sol('sol1').feature('st1').set('keeplog', true);
model.sol('sol1').feature('v1').set('clist', {'range(0,((1/frq)*2-0)/3999,(1/frq)*2)'});
model.sol('sol1').feature('t1').set('tlist', 'range(0,((1/frq)*2-0)/3999,(1/frq)*2)');
model.sol('sol1').feature('t1').set('timemethod', 'genalpha');
model.sol('sol1').feature('t1').set('tstepsgenalpha', 'manual');
model.sol('sol1').feature('t1').set('rhoinf', 0.825);
model.sol('sol1').feature('t1').set('timestepgenalpha', '0.001');
model.sol('sol1').feature('t1').set('keeplog', true);
model.sol('sol1').runAll;

model.result('pg3').label('Computed EM force plot');
model.result('pg3').set('xlabel', 'Time (s)');
model.result('pg3').set('xlabelactive', false);
model.result('pg4').label('Integrated Downward surface electric stress tensor');
model.result('pg4').set('xlabel', 'Time (s)');
model.result('pg4').set('xlabelactive', false);
model.result('pg4').feature('tblp1').set('table', 'tbl2');

out = model;
